library tags.html;

import 'dart:async';
import 'dart:html';
import 'dart:svg' show SvgElement;
import 'tags.dart';

part 'view/command_binding.dart';
part 'view/editable_label.dart';
part 'view/editor_view.dart';
part 'view/toggle_button.dart';
part 'view/toggle_open.dart';
part 'view/tree_view.dart';

Document get _htmlDocument => document;

const Dom HTML = const _Dom();

class _Dom extends Dom {
  
  const _Dom();
  
  static bool _isRegistered = false;
  
  get document => _htmlDocument;
  
  void registerElements() {
    if (!_isRegistered) {
      _isRegistered = true;
      CommandBinding.focusRoot = window;
      document.registerElement(CommandBinding.TAG, CommandBinding);
      document.registerElement(EditableLabel.TAG, EditableLabel, 
          extendsTag: 'div');
      document.registerElement(ToggleButton.TAG, ToggleButton, 
          extendsTag: 'button');
      document.registerElement(ToggleOpen.TAG, ToggleOpen);
    }
  }
  
  createElement(String tag, [String typeExtention]) => 
      new Element.tag(tag, typeExtention);
  
  createSvgElement(String tag) => new SvgElement.tag(tag);
}
