part of tags;

abstract class Editor<T> {
  
// -----------------------------------------------------------------------------
// Implemented in the EditorView base class; not designed for override.
// -----------------------------------------------------------------------------
  
  /// The current object selected for edition; may be `null`.
  T selection;
  
  /// Returns `true` if the [selection] is not `null`.
  bool get hasSelection;
  Stream<T> get onSelectionChange;  
  get context;
  bool get isAttached;
  bool get isShown;
  
  void initialize(T selection, [context]);
  void shutdown();
    
  void show({bool select: true});
  void hide();
    
// -----------------------------------------------------------------------------
// Stubbed in the EditorView base class and designed for override.
// -----------------------------------------------------------------------------
  
  Command get copy;
  Command get cut;
  Command get paste;
  Command get redo;
  Command get undo;
  Command get zoomIn;
  Command get zoomOut;
  
  void initialize_(T selection, context);
  void shutdown_();
  
  void attached_();
  void detached_();
  
  void show_();
  void hide_();
  
  void select_(T selection);
}
