part of tags;

class KeyBinding {
  
  final int _key;
  final bool _alt;
  final bool _ctrl;
  final bool _shift;
  
  KeyBinding(this._key, {bool alt: false, bool ctrl: false, bool shift: false})
  : _alt = alt
  , _ctrl = ctrl
  , _shift = shift;
    
  /// Returns `true` if the given [keyEvent] matches this key binding.
  bool matchKeys(keyEvent) => keyEvent.keyCode == this._key 
      && keyEvent.altKey == this._alt
      && keyEvent.ctrlKey == this._ctrl
      && keyEvent.shiftKey == this._shift;
    
  String toString() => 
      '${_alt ? 'Alt+' : ''}${_ctrl ? 'Ctrl+' : ''}${_shift ? 'Shift+' : ''}'
      '${new String.fromCharCode(_key)}';
}
